unit PlaybackDemo;

interface

uses
  Windows, Messages, SysUtils,  Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ToolWin, ExtCtrls, TeeProcs, TeEngine, Chart,
  SignalToolsTee, TeeEdit, SignalToolsDialogs, SpectrumAna, MtxBaseComp,
  SignalTools, SignalAnalysis, Series, StdCtrls, TeeTools, FileSignal,
  MtxDialogs, SignalProcessing, AudioSignal, MtxComCtrls, SignalUtils;

type
  TPlaybackDemoForm = class(TForm)
    Panel1: TPanel;
    ToolBar1: TToolBar;
    SpectrumEditButton: TToolButton;
    ChartButton: TToolButton;
    SpectrumAnalyzer: TSpectrumAnalyzer;
    SpectrumAnalyzerDialog: TSpectrumAnalyzerDialog;
    ChartEditor: TChartEditor;
    RichEdit1: TRichEdit;
    Panel2: TPanel;
    SpectrumChart: TSpectrumChart;
    Series1: TFastLineSeries;
    Series2: TPointSeries;
    ChartTool1: TAxisScaleTool;
    Splitter1: TSplitter;
    SignalChart1: TSignalChart;
    Series3: TFastLineSeries;
    SignalTimer1: TSignalTimer;
    Signal1: TSignal;
    ChannelBox: TComboBox;
    Label1: TLabel;
    SignalOut1: TSignalOut;
    SignalRead1: TSignalRead;
    ToolButton1: TToolButton;
    OpenDialog1: TOpenDialog;
    procedure SpectrumEditButtonClick(Sender: TObject);
    procedure SpectrumAnalyzerParameterUpdate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Panel2Resize(Sender: TObject);
    procedure SignalTimer1Timer(Sender: TObject);
    procedure ChartButtonClick(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
  private
    procedure WaitForPlayback;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PlaybackDemoForm: TPlaybackDemoForm;

implementation

uses Math387, MtxVec;

{$R *.dfm}

procedure TPlaybackDemoForm.SpectrumEditButtonClick(Sender: TObject);
begin
     SpectrumAnalyzerDialog.Execute;
end;

procedure TPlaybackDemoForm.SpectrumAnalyzerParameterUpdate(
  Sender: TObject);
begin
    SpectrumAnalyzer.Update;
end;

procedure TPlaybackDemoForm.FormCreate(Sender: TObject);
begin
    Signal1.Data.Size(2048);  //defines how much data to copy
    Signal1.UsesInputs := false;
    SignalRead1.Length := 2048;  //this will automatically set the size of the SignalOut buffer!!
    
    ChannelBox.ItemIndex := 0;

    With RichEdit1.Lines, RichEdit1 do
    begin
      Clear;
      Add('Open an uncompressed PCM wav file. The signal display and spectrum analyzer will be ' +
          'updated with a frequency independent of the audio stream being played back. ' +
          'Note the smooth and very responsive display next to the clean playback. '+
          'The screen update frequency is 20Hz, frequency spectrum is based on 2048 samples ' +
          'and this requires only 20% of 1GHz CPU.');
    end;
end;


procedure TPlaybackDemoForm.Panel2Resize(Sender: TObject);
begin
    SpectrumChart.Height := Panel2.Height div 2;
end;

procedure TPlaybackDemoForm.SignalTimer1Timer(Sender: TObject);
begin
    if not SignalOut1.Active then Exit;
    case TChannel(ChannelBox.ItemIndex) of
    chLeft:  SignalOut1.MonitorData(Signal1, nil    );
    chRight: SignalOut1.MonitorData(nil    , Signal1);
    end;
    SpectrumAnalyzer.Pull;  //calls update on Signal1 and Self
end;

procedure TPlaybackDemoForm.ChartButtonClick(Sender: TObject);
begin
     ChartEditor.Execute;
end;

procedure TPlaybackDemoForm.WaitForPlayback;
var i: integer;
begin
    SignalOut1.StopAtOnce;
    i := 0;
    while i < 10 do
    begin
         Inc(i);
         Application.ProcessMessages;
         Sleep(20);
    end;
end;

procedure TPlaybackDemoForm.ToolButton1Click(Sender: TObject);

begin
     if OpenDialog1.Execute then
     begin
          WaitForPlayback;   //because you can not start right after being stopped
          SignalRead1.FileName := OpenDialog1.FileName;
          SignalOut1.Start;
     end;
end;


initialization
RegisterClass(TPlaybackDemoForm);

end.
