{*******************************************}
{   Signal Tools 1.0 DSP Components	    }
{    					    }
{   Types: TMarkRecord                      }
{                                           }
{   Components: TMarkCursorEdit             }
{                                           }
{   Copyright (c) 1997-2003 Dew Research    }
{                 Janez Makovsek            }
{   All Rights Reserved                     }
{*******************************************}
{$IMPORTEDDATA ON}
unit SignalMarkToolEdit;
{$I BdsppDefs.inc}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ComCtrls, SignalToolsTee;

type
  TSignalMarkToolEditor = class(TForm)
    MarkPageControl: TPageControl;
    TabSheet1: TTabSheet;
    SpeedButton1: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    SpectrumBox: TComboBox;
    MarkSeriesBox: TComboBox;
    MarkModeBox: TComboBox;
    CoordinatesBox: TCheckBox;
    ActiveBox: TCheckBox;
    DoubleClickClear: TCheckBox;
    TabSheet2: TTabSheet;
    GroupBox1: TGroupBox;
    AmplitudeEdit: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    TimeEdit: TEdit;
    CheckBox1: TCheckBox;
    procedure DoubleClickClearClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SpectrumBoxChange(Sender: TObject);
    procedure MarkSeriesBoxChange(Sender: TObject);
    procedure MarkModeBoxChange(Sender: TObject);
    procedure CoordinatesBoxClick(Sender: TObject);
    procedure ActiveBoxClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure AmplitudeEditChange(Sender: TObject);
    procedure TimeEditChange(Sender: TObject);
  private
    { Private declarations }
  public
    MarkTool: TSignalMarkTool;
    { Public declarations }
  end;

var
  SignalMarkToolEditor: TSignalMarkToolEditor;

implementation

uses TeEngine, TeeConst;

{$R *.dfm}

procedure TSignalMarkToolEditor.DoubleClickClearClick(Sender: TObject);
begin
   MarkTool.DoubleClickClear := DoubleClickClear.Checked;
end;

procedure TSignalMarkToolEditor.FormShow(Sender: TObject);
begin
  MarkTool := TSignalMarkTool(Tag);
  with MarkTool, SpectrumBox do
  begin
     FillSeriesItems(Items,ParentChart);
     Enabled := ParentChart.SeriesCount>0;
     Items.InsertObject(0,TeeMsg_None,nil);
     ItemIndex := Items.IndexOfObject(Series);
  end;
  With MarkTool, MarkSeriesBox do
  begin
     FillSeriesItems(Items,ParentChart);
     Enabled := ParentChart.SeriesCount>0;
     Items.InsertObject(0,TeeMsg_None,nil);
     ItemIndex := Items.IndexOfObject(MarkSeries);
  end;
  MarkModeBox.ItemIndex := Integer(MarkTool.MarkMode);
//  CoordinatesBox.Checked := MarkTool.DisplayCoordinates;
  ActiveBox.Checked := MarkTool.CursorActive;
  AmplitudeEdit.Text := MarkTool.AmpltFormat;
  TimeEdit.Text := MarkTool.TimeFormat;
end;

procedure TSignalMarkToolEditor.SpectrumBoxChange(Sender: TObject);
begin
  With SpectrumBox do MarkTool.Series:=TChartSeries(Items.Objects[ItemIndex]);
end;

procedure TSignalMarkToolEditor.MarkSeriesBoxChange(Sender: TObject);
begin
    With MarkSeriesBox do MarkTool.MarkSeries:=TChartSeries(Items.Objects[ItemIndex]);
end;

procedure TSignalMarkToolEditor.MarkModeBoxChange(Sender: TObject);
begin
    MarkTool.MarkMode := TSignalMarkMode(MarkModeBox.ItemIndex);
end;

procedure TSignalMarkToolEditor.CoordinatesBoxClick(Sender: TObject);
begin
//    MarkTool.DisplayCoordinates := CoordinatesBox.Checked;
end;

procedure TSignalMarkToolEditor.ActiveBoxClick(Sender: TObject);
begin
     MarkTool.CursorActive :=  ActiveBox.Checked;
end;

procedure TSignalMarkToolEditor.SpeedButton1Click(Sender: TObject);
begin
     MarkTool.ClearMarks;
end;

procedure TSignalMarkToolEditor.AmplitudeEditChange(Sender: TObject);
begin
    MarkTool.AmpltFormat := AmplitudeEdit.Text;
end;

procedure TSignalMarkToolEditor.TimeEditChange(Sender: TObject);
begin
    MarkTool.TimeFormat := TimeEdit.Text;
end;

initialization
RegisterClass(TSignalMarkToolEditor);

end.
